from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import String, Boolean, Directory, Float, File, Int

Mast_V0_1_0 = CommandToolBuilder(tool="mast", base_command=["mast"], inputs=[ToolInput(tag="in_b_file", input_type=String(optional=True), prefix="-bfile", doc=InputDocumentation(doc="read background frequencies from <bf>")), ToolInput(tag="in_db_list", input_type=Boolean(optional=True), prefix="-dblist", doc=InputDocumentation(doc="the file specified as database contains a list of databases")), ToolInput(tag="in_directory_to_output_mast_results", input_type=Directory(optional=True), prefix="-o", doc=InputDocumentation(doc="directory to output mast results")), ToolInput(tag="in_oc", input_type=Directory(optional=True), prefix="-oc", doc=InputDocumentation(doc="directory to output mast results with overwriting allowed")), ToolInput(tag="in_hit_list", input_type=Boolean(optional=True), prefix="-hit_list", doc=InputDocumentation(doc="print only a list of non-overlapping hits to stdout")), ToolInput(tag="in_rem_corr", input_type=Boolean(optional=True), prefix="-remcorr", doc=InputDocumentation(doc="remove highly correlated motifs from query")), ToolInput(tag="in_use_only_motifs_named", input_type=String(optional=True), prefix="-m", doc=InputDocumentation(doc="use only motif(s) named <id> (overrides -mev);\ncan be repeated")), ToolInput(tag="in_mi", input_type=String(optional=True), prefix="-mi", doc=InputDocumentation(doc="use only motif(s) numbered <m> (overrides -mev);\ncan be repeated")), ToolInput(tag="in_only_use_motifs", input_type=String(optional=True), prefix="-c", doc=InputDocumentation(doc="only use the first <count> motifs or all motifs\nwhen <count> is zero")), ToolInput(tag="in_mev", input_type=String(optional=True), prefix="-mev", doc=InputDocumentation(doc="use only motifs with E-values (or p-values) less than\nor equal to <thresh>")), ToolInput(tag="in_diag", input_type=String(optional=True), prefix="-diag", doc=InputDocumentation(doc="nominal order and spacing of motifs")), ToolInput(tag="in_norc", input_type=Boolean(optional=True), prefix="-norc", doc=InputDocumentation(doc="do not score reverse complement DNA strand")), ToolInput(tag="in_sep", input_type=Boolean(optional=True), prefix="-sep", doc=InputDocumentation(doc="score reverse complement DNA strand as a separate sequence")), ToolInput(tag="in_dna", input_type=Boolean(optional=True), prefix="-dna", doc=InputDocumentation(doc="translate DNA sequences to protein")), ToolInput(tag="in_comp", input_type=Boolean(optional=True), prefix="-comp", doc=InputDocumentation(doc="adjust p-values and E-values for sequence composition")), ToolInput(tag="in_ev", input_type=Float(optional=True), prefix="-ev", doc=InputDocumentation(doc="print results for sequences with E-value < <ev>;\ndefault: 0.0001")), ToolInput(tag="in_mt", input_type=Float(optional=True), prefix="-mt", doc=InputDocumentation(doc="show motif matches with p-value < mt; default: 9.53282e-130")), ToolInput(tag="in_show_weak_matches", input_type=Boolean(optional=True), prefix="-w", doc=InputDocumentation(doc="show weak matches (mt < p-value < mt*10) in angle brackets")), ToolInput(tag="in_best", input_type=Boolean(optional=True), prefix="-best", doc=InputDocumentation(doc="include only the best motif in diagrams;\nhit_list mode only")), ToolInput(tag="in_seq_p", input_type=Boolean(optional=True), prefix="-seqp", doc=InputDocumentation(doc="use SEQUENCE p-values for motif thresholds\ndefault: use POSITION p-values")), ToolInput(tag="in_mv", input_type=File(optional=True), prefix="-mv", doc=InputDocumentation(doc="in results use <mf> as motif file name")), ToolInput(tag="in_df", input_type=String(optional=True), prefix="-df", doc=InputDocumentation(doc="in results use <df> as database name; ignored when\noption -dblist is specified")), ToolInput(tag="in_dl", input_type=String(optional=True), prefix="-dl", doc=InputDocumentation(doc="in results use <dl> as link to search sequence names;\nignored when -dblist specified")), ToolInput(tag="in_mins_eqs", input_type=Int(optional=True), prefix="-minseqs", doc=InputDocumentation(doc="lower bound on number of sequences in db")), ToolInput(tag="in_no_status", input_type=Boolean(optional=True), prefix="-nostatus", doc=InputDocumentation(doc="do not print progress report")), ToolInput(tag="in_no_text", input_type=Boolean(optional=True), prefix="-notext", doc=InputDocumentation(doc="do not generate text output")), ToolInput(tag="in_no_html", input_type=Boolean(optional=True), prefix="-nohtml", doc=InputDocumentation(doc="do not generate html output")), ToolInput(tag="in_version", input_type=Boolean(optional=True), prefix="-version", doc=InputDocumentation(doc="print the version and exit")), ToolInput(tag="in_motif_file", input_type=File(), position=0, doc=InputDocumentation(doc="")), ToolInput(tag="in_sequence_file", input_type=File(), position=1, doc=InputDocumentation(doc=""))], outputs=[ToolOutput(tag="out_directory_to_output_mast_results", output_type=Directory(optional=True), selector=InputSelector(input_to_select="in_directory_to_output_mast_results", type_hint=File()), doc=OutputDocumentation(doc="directory to output mast results")), ToolOutput(tag="out_oc", output_type=Directory(optional=True), selector=InputSelector(input_to_select="in_oc", type_hint=File()), doc=OutputDocumentation(doc="directory to output mast results with overwriting allowed"))], container="quay.io/biocontainers/meme:5.3.0--py38pl526hc1f1133_0", version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Mast_V0_1_0().translate("wdl")

